
it.emasab.Mailclassifier.SetClassificationTokenListener = function(account,folder){
	this.account=account;
	this.folder=folder;
	this.onTokenAvailable=function(uri,tokenizer){
		this.account.onSetClassificationTokenAvailable(uri,this.folder,tokenizer);
	}
}

it.emasab.Mailclassifier.Account = function(mozillaAcc,controller){

	this.setTokenizer=function(uri,tokenizer){
		//var mail=this.mail[uri];
		//if(mail) mail.tokenizer=tokenizer; 		
	}
	this.onTokenAvailable=function(uri,tokenizer){
		this.setTokenizer(uri,tokenizer);
		this.filter.classifyMessage(uri,null,this,tokenizer);	
	}
	this.onSetClassificationTokenAvailable=function(uri,folder,tokenizer){
		dump("onSetClassificationTokenAvailable\n");
		this.setTokenizer(uri,tokenizer);
		this.setClassificationWithTokenizer(uri,folder,tokenizer);
	}
	this.setClassificationWithTokenizer=function(uri,folder,tokenizer){
		folder.setMessageClassification(uri,tokenizer);	
	}
	this.onMessageClassified=function(msgUri,folderURI,classification){		
		classification=classification/100;	
		var msg=this.mail[msgUri];
		var folder=this.getFolderForURI(folderURI);
		if(msg && classification>=this.minP){
			msg.setClassification(folder,classification);
		}
	}

	this.endClassification = function(msguri){
		it.emasab.Mailclassifier.refreshClassifications();
		if(it.emasab.Mailclassifier.mcProgDialog) it.emasab.Mailclassifier.mcProgDialog.classified(msguri);
		/*moveOnC = it.emasab.Mailclassifier.Services.pref.getBoolPref("mailclassifier.preferences.moveOnClassification");
		var msg=this.mail[msguri];
		if(moveOnC && msg){
			best = 	msg.getBest()
			if(best){
				mozmsg = msg.getMessageHdr()
				folder_src = mozmsg.folder;
				folder_dst = best.mozillaFolder;
				list = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
				list.AppendElement(mozmsg);
				it.emasab.Mailclassifier.Services.copyservice.CopyMessages(folder_src, list, folder_dst , true , null , msgWindow , false );
			}		
		}*/
	}

	this.endTraining = function(msguri){
		it.emasab.Mailclassifier.refreshClassifications();
		if(it.emasab.Mailclassifier.mcProgDialog) it.emasab.Mailclassifier.mcProgDialog.classified(msguri);
	}

	this.classifyMessage=function(msg){
		it.emasab.Mailclassifier.debug("classifyMessage: " + msg.msgURI);
		var msg1=this.mail[msg.msgURI];
		if(!msg1){
			this.mail[msg.msgURI]=msg;
			msg1=msg;
		}
		it.emasab.Mailclassifier.debug("classified: " + msg1.isClassified());
		if(!msg1.isClassified()){			
			this.controller.setAccountForURI(msg.msgURI,this);
			if(this.uFolders.length>0){
				var tok=msg1.tokenizer;
				if(!tok){
					it.emasab.Mailclassifier.tokenizeMessage(msg.msgURI,this);
				}
				else{
					this.onTokenAvailable(msg.msgURI,tok);
				}
			}
		}
		else{
			it.emasab.Mailclassifier.refreshClassifications();
		}
	}
	this.unclassifyMessage=function(msgURI){
		var mail=this.mail[msgURI];
		if(mail) mail.removeClassifications();
	}
	this.forceClassify=function(msg){
		this.unclassifyMessage(msg.msgURI);
		this.classifyMessage(msg);
	}
	this.getClassificationFor=function(msgURI){
		return this.mail[msgURI];
	}
	this.setClassificationFor=function(msgURI,folderURI){
		var folder=null;
		var msg=new it.emasab.Mailclassifier.Message(msgURI);
		this.mail[msgURI]=msg;
		this.controller.setAccountForURI(msgURI,this);
		
		for(var i=0;i<this.uFolders.length;i++){
			var fol=this.uFolders[i];
			if(fol.getURI()==folderURI){
				folder=fol;
				break;
			}
		}
		if(folder){	
			msg.setClassification(folder,1);
		}
	}
	this.getFolderForMozillaFolder=function(mozFolder){
		var ret=null;
		for(var i=0;i<this.uFolders.length;i++){
			var fol=this.uFolders[i];
			if(fol.mozillaFolder==mozFolder){
				ret=fol;
				break;
			}
		}
		return ret;
	}
	this.getFolderForURI=function(uri){
		var ret=null;
		for(var i=0;i<this.uFolders.length;i++){
			var fol=this.uFolders[i];
			if(fol.mozillaFolder.URI==uri){
				ret=fol;
				break;
			}
		}
		return ret;
	}
	this.removeUFolder=function(mozFolder){
		var a=new Array();
		for(x in this.uFolders){
			ufol=this.uFolders[x];
			if(ufol.mozillaFolder==mozFolder){
				//dump("delete : "+ufol.mozillaFolder.name+"\n");
				//delete this.uFolders[x];
			}
			else a.push(ufol);
		}
		this.uFolders=a;
		for(x in this.mail){
			msg=this.mail[x];
			msg.removeFolder(mozFolder);
		}		
	}
	this.removeFolderFromClassifications=function(mozFolder){
		var folder=this.getFolderForMozillaFolder(mozFolder);
		if(folder!=null){
			folder.removed(this);
			/*var added=null;
			var account=null;
			if(controller.addedFolders.length>0){
				added= controller.addedFolders.shift().mozillaFolder;
				account= controller.addedFolders.shift();
				dump(added.name);
			}
			if(added!=null && added.name==folder.mozillaFolder.name){
				account.changeFolderTo(added,folder);
			}
			else{*/

			//}
		}
	}
	this.excludeFolder = function(mozFolder){
		this.removeFolderFromClassifications(mozFolder);
		this.blockedFolders.push(mozFolder.URI);
	}
	this.includeFolder = function(mozFolder){
		b = new Array();
		for(b1 in this.blockedFolders){
			b1 = this.blockedFolders[b1];
			if(b1!=mozFolder.URI) b.push(b1);		
		}	
		this.blockedFolders = b;
		this.addFolderToClassifications(mozFolder);	
	}
	this.getExcluded = function(mozFolder){
		for(b in this.blockedFolders){
			b = this.blockedFolders[b];
			if(b==mozFolder.URI) return true;		
		}
		return false;
	}
	this.changeExcluded = function(mozFolder){
		var excluded = this.getExcluded(mozFolder);
		if(excluded) this.includeFolder(mozFolder);
		else this.excludeFolder(mozFolder);
		this.writeData();
	}
	this.clearClassifications = function(){
		this.mail = new Array();	
	}
	this.changeFolderTo=function(mozFolder,uFolder){
		var parent=this.getFolderForMozillaFolder(mozFolder.parent);
		this.removeUFolder(mozFolder);
		uFolder.changeMozFolder(mozFolder,this,true,parent);
	}
	this.addFolderToClassifications=function(mozFolder){
		for(i in this.blockedFolders) if(this.blockedFolders[i]==mozFolder.URI) return;
		var parent=mozFolder.parent;
		parent=this.getFolderForMozillaFolder(parent);
		var ufolder=new it.emasab.Mailclassifier.UFolder(mozFolder,this,parent);
		//controller.addedFolders=new Array();
		//controller.addedFolders.push(ufolder);
		//controller.addedFolders.push(this);
		//dump(controller.addedFolders.length+"ciao");
	}
	this.setClassification=function(msgURI,folder){
		var msg=this.mail[msgURI];
		if(!msg) msg=new it.emasab.Mailclassifier.Message(msgURI);
		else msg.removeClassifications();
		this.mail[msgURI]=msg;
		var fol=this.getFolderForMozillaFolder(folder);
		if(fol){
			it.emasab.Mailclassifier.debug("set folder " + msgURI + "," + folder.name);
			var tok=msg.tokenizer;
			if(!tok){
				var list=new it.emasab.Mailclassifier.SetClassificationTokenListener(this,fol);
				dump("beforeTokenize");
				it.emasab.Mailclassifier.tokenizeMessage(msgURI,list);
				dump("afterTokenize");
			}
			else{
				this.setClassificationWithTokenizer(msgURI,fol,tok);
			}	
		}	
	}
	this.observe=function(subject,topic,data){
		dump(topic + "\n");
		if(topic=="quit-application"){
			this.shutdown();
		}
	}
	this.writeData = function(){
		this.filter.writeTrainingData();
		this.cache.save();
		this.blocked.save();
	}
	this.shutdown=function(){
		this.cache.save();
		this.blocked.save();
	}
	this.cannotCreate=function(e){
		alert(e);
		alert(it.emasab.Mailclassifier.Services.extbundle.GetStringFromName("ufolder.cannot_create"));
	}
	this.getUFolders=function(){
		return this.uFolders.sort(it.emasab.Mailclassifier.folderCompare);
	}

	this.getInbox = function(){
		return this.mozAccount.rootMsgFolder.getFolderWithFlags(nsMsgFolderFlags.Inbox);
	}

	this.resetTrainingData = function(){
		if(this.filter) this.filterSync.resetTrainingData();
	}

	this.lookIn=function(root){
		var folders = root.subFolders;
		while(folders.hasMoreElements()){
			try {
				var folder = folders.getNext().QueryInterface(Components.interfaces.nsIMsgFolder);
				if(it.emasab.Mailclassifier.isUserFolder(folder)){
					if(!this.getExcluded(folder)){		
						var ufolder=new it.emasab.Mailclassifier.UFolder(folder,this);
					}
				}
				if(it.emasab.Mailclassifier.isInbox(folder)) this.lookIn(folder);
        		} 
        		catch (ex){
				dump(ex);
        		}
		}
	}

	this.uFolders=new Array();
	this.mail = new Array();
	this.blockedFolders = new Array();
	this.minP=0.6;
	this.mozAccount=mozillaAcc;
	this.controller=controller;
	this.cache=new it.emasab.Mailclassifier.ClassificationCache(this);
	this.blocked=new it.emasab.Mailclassifier.BlockedFolders(this);
	it.emasab.Mailclassifier.Services.observerService.addObserver(this,"quit-application",false);
	var rootFolder=mozillaAcc.rootFolder.QueryInterface(Components.interfaces.nsIMsgFolder);
	var rootName=rootFolder.name;
	try{	
		this.filter=it.emasab.Mailclassifier.createProxy(Components.classes['@uniroma3.it/MailClassifier/nsMCFilter;1'],Components.interfaces.nsIMCFilter,it.emasab.Mailclassifier.Constants.proxyAsync);
		this.filterSync=it.emasab.Mailclassifier.getSyncProxy(this.filter, Components.interfaces.nsIMCFilter);
		this.filter.setFolder(rootFolder);
	}
	catch(e){
		dump(e);
		this.cannotCreate(e);
	}
	
	this.blocked.load();
	this.lookIn(rootFolder);
	
	try{	
		this.filter.init();
	}
	catch(e){
		this.cannotCreate(e);
	}
	this.cache.load();
}
